;    .
; windlg.asm
;defs32.inc

WM_INITDIALOG		equ	110h
WM_CLOSE		equ	10h
WM_COMMAND		equ	111h
WM_CHAR			equ	102h

WM_SETICON equ 80h

WM_SETTEXT		equ	12
WM_GETTEXT equ 13

WM_KEYDOWN		equ	100h
WM_KEYUP		equ 	101h
WM_SYSKEYDOWN		equ 	104h
WM_SYSKEYUP		equ 	105h

VK_MENU equ 12h
VK_SHIFT equ 10h
VK_CONTROL equ 11h
VK_BACK			equ	8
VK_LWIN equ 5Bh
VK_RWIN equ 5Ch


GWL_WNDPROC		equ	-4

VK_LWIN_		equ 	5B0000h
VK_RWIN_		equ	5C0000h

MOD_ALT			equ 1
MOD_CONTROL		equ 2
MOD_SHIFT		equ 4
MOD_WIN			equ 8

;---------------------------------------------include DEFS32.INC
	includelib	import32.lib
	extrn	ExitProcess:proc
	extrn	GetModuleHandleA:proc
	extrn	SendMessageA:proc
	extrn	lstrlenA:proc

	extrn	DialogBoxParamA:proc

;	extrn	EndDialog:proc
	extrn	GetDlgItem:proc
	extrn	GetDlgItemInt:proc
	extrn	SetDlgItemInt:proc

	extrn	GlobalAlloc:near
	extrn	GlobalFree:near

	extrn GetWindowRect:proc
	extrn SetWindowPos:proc
	extrn GetDesktopWindow:proc
	extrn LoadIconA:proc

;---------------------------------------------include APICALLS.INC
RECT	struc
	l	dd	?
	t	dd	?
	r	dd	?
	b	dd	?
RECT	ends

	.386
	.model flat,stdcall


	.data?
dtr RECT<?,?,?,?>
dlr RECT<?,?,?,?>
hinst dd ?
	.data
ww: dd 0
	.code
_start:
	xor	ebx,ebx
	call	GetModuleHandleA,ebx
	mov hinst,eax
	call	DialogBoxParamA,eax,300,ebx,offset	dialog_proc,ebx

failure:
	call	ExitProcess,ebx

dialog_proc	proc	near
	push	ebp
	mov	ebp,esp
dp_hWnd		equ	dword ptr [ebp+08h] ; DIALOG_id
dp_uMsg		equ	dword ptr [ebp+0Ch] ; message #
dp_wParam	equ	dword ptr [ebp+10h] ; 1st param.
dp_lParam	equ	dword ptr [ebp+14h] ; 2nd param.

	mov	ecx,dp_hWnd
	mov	eax,dp_uMsg
	cmp	eax,WM_INITDIALOG
	jne	not_initdialog

;initialisation dialogs
	call GetDesktopWindow
	call GetWindowRect,eax,offset dtr
	call GetWindowRect,dp_hWnd,offset dlr
	mov eax,dtr.r
	sub eax,dlr.r
	shr eax,1
	mov ecx,dtr.b
	sub ecx,dlr.b
	shr ecx,1
HWND_TOP equ 0
SWP_NOSIZE equ 1
	call SetWindowPos,dp_hWnd,HWND_TOP,eax,ecx,0,0,SWP_NOSIZE
ICON_SMALL equ 0
	call LoadIconA,hinst,500
	call SendMessageA,dp_hWnd,WM_SETICON, ICON_SMALL,eax

	jmp	not_exit
not_initdialog:
	cmp	eax,WM_CLOSE
	jne	not_close

close_dlg:
	jmp failure;;call	EndDialog,ecx,0
not_close:
	cmp	eax,WM_COMMAND
	jne	not_command
	mov	eax,dp_wParam
	cmp	eax,2
	je	close_dlg

EN_UPDATE equ 400h
	cmp	ax,302;   2 - 
	je test2
;	shr	eax,10h
;	cmp	eax,EN_UPDATE
;    je process_field
;	jmp	not_exit


	cmp	ax,301;   - 
	jne	not_exit
	
test2:
	shr	eax,10h
	cmp	eax,EN_UPDATE
    je process_field
	jmp	not_exit

process_field:
GMEM_FIXED equ 0h
GMEM_ZEROINIT equ 40h
WM_GETTEXTLENGTH equ 14

	push esi
	push edi

	call GetDlgItem,dp_hWnd,301
	call SendMessageA,eax,WM_GETTEXTLENGTH,0,0
	inc eax
	push eax
	call	GlobalAlloc,GMEM_FIXED+GMEM_ZEROINIT,eax
	mov esi,eax
	call GetDlgItem,dp_hWnd,301
	pop ecx
	call SendMessageA,eax,WM_GETTEXT,ecx,esi

	call GetDlgItem,dp_hWnd,302
	call SendMessageA,eax,WM_GETTEXTLENGTH,0,0
	inc eax
	push eax
	call	GlobalAlloc,GMEM_FIXED+GMEM_ZEROINIT,eax
	mov edi,eax
	call GetDlgItem,dp_hWnd,302
	pop ecx
	call SendMessageA,eax,WM_GETTEXT,ecx,edi

	call GetDlgItem,dp_hWnd,303
	call SendMessageA,eax,WM_SETTEXT,eax,0

	xor eax,eax

	push esi
pr_lp:
	mov al,[esi]
	or al,al
	je done_k
	cmp al,34
	jne not_k

	call lstrlenA,edi
	or eax,eax
	jne len_is_ok
	mov eax,34
	jmp not_k
len_is_ok:
EM_REPLACESEL equ 0c2h
	call GetDlgItem,dp_hWnd,303
	call SendMessageA,eax,EM_REPLACESEL,0,edi
    jmp next_ch
not_k:
	mov	dp_wParam,eax

	call GetDlgItem,dp_hWnd,303
	lea ecx,dp_wParam
	call SendMessageA,eax,EM_REPLACESEL,0,ecx
next_ch:
	inc esi
	jmp pr_lp

;-------------------------end program
done_k:
    pop esi
	call GlobalFree,esi
	call GlobalFree,edi
	pop edi
	pop esi
 jmp not_exit;end_proc
;------------------------------------------------------------
not_exit:
	xor	eax,eax
	inc	eax
	leave
	ret	16
not_command:
	xor	eax,eax
	leave
	ret	16
dialog_proc	endp
end	_start
